

local SentientHat = Class(function(self, inst)
    self.inst = inst
    self.time_to_convo = 10
	local rincewind = GetPlayer()

    self.inst:ListenForEvent("ondropped", function() self:OnDropped() end)
    self.inst:ListenForEvent("equipped", function(_, data) self:OnEquipped(data.owner) end)
	rincewind:ListenForEvent("healthdelta", function() self:ComplainHurt() end) 
    local dt = 5
    self.inst:DoPeriodicTask(dt, function() self:OnUpdate(dt) end)
    self.warnlevel = 0

end)

function SentientHat:ComplainHurt()
	local rincewind = GetPlayer()
	if rincewind.hpdown then
		self:Say(STRINGS.CHARACTERS.RNW.fear)
	end
end

function SentientHat:OnDropped()
    self:Say(STRINGS.CHARACTERS.RNW.on_dropped)
end

function SentientHat:OnEquipped(picked_up_by)
    if picked_up_by == GetPlayer() then
        self:Say(STRINGS.CHARACTERS.RNW.on_pickedup) 
    end
end

function SentientHat:OnUpdate(dt)
    self.time_to_convo = self.time_to_convo - dt
    if self.time_to_convo <= 0 then
        self:MakeConversation()
    end
end

function SentientHat:Say(list)--, sound_override)
	local rincewind = GetPlayer()
    --self.sound_override = sound_override
    rincewind.components.talker:Say(list[math.random(#list)])
    self.time_to_convo = math.random(60, 120)
end




function SentientHat:MakeConversation()
    
    local grand_owner = self.inst.components.inventoryitem:GetGrandOwner()
    local owner = self.inst.components.inventoryitem.owner

    local quiplist = nil
    if owner == GetPlayer() then
        if self.inst.components.equippable:IsEquipped() then
            --currently equipped
            quiplist = STRINGS.CHARACTERS.RNW.equipped
        else
            --in player inventory
        end
    end

    if quiplist then
        self:Say(quiplist)
    end
end

return SentientHat