------------------------------------------------------------------
local Assets =
{
		Asset("ANIM", "anim/hat_wizzard.zip"),
		Asset("IMAGE", "images/inventoryimages/hat_wizzard.tex"),
		Asset("ATLAS", "images/inventoryimages/hat_wizzard.xml"),
}
local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_hat", "hat_wizzard", "swap_hat")
	owner.AnimState:Show("HAT")
	owner.AnimState:Hide("HAIR_NOHAT")
	owner.AnimState:Hide("HAIR")
	
	inst.components.dapperness.dapperness = 4.1
	inst.components.equippable.dapperness = 4.1
	
	if owner.components.builder then
		owner.components.builder.magic_bonus = 2
	end
	
	if owner:HasTag("player") then
		owner.AnimState:Hide("HEAD")
		owner.AnimState:Show("HEAD_HAIR")
	end
	
	if inst.components.fueled then
		inst.components.fueled:StartConsuming()
	end
end

local function onunequip(inst, owner)
	owner.AnimState:Hide("HAT")
	owner.AnimState:Show("HAIR_NOHAT")
	owner.AnimState:Show("HAIR")
	
	if owner.components.builder then
		owner.components.builder.magic_bonus = 0
	end
	
	if owner:HasTag("player") then
		owner.AnimState:Show("HEAD")
		owner.AnimState:Hide("HEAD_HAIR")
	end
	
	if inst.components.fueled then
		inst.components.fueled:StopConsuming()
	end
	
end



local function fn(Sim)
	local rincewind = GetPlayer()
	if rincewind then
		if rincewind.components.inventory:Has("hat_wizzard", 1) then return end
		for k, v in pairs (rincewind.components.inventory.equipslots) do
			if v.prefab == "hat_wizzard" then
				return
			end
		end 
	end
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)
	inst.AnimState:SetBank("tophat")
	inst.AnimState:SetBuild("hat_wizzard")
	inst.AnimState:PlayAnimation("anim")
	inst:AddTag("hat")
	inst:AddTag("hat_wizzard")
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon("hat_wizzard.tex")
	--inst:AddComponent("builder")  -- disabled, useless
	-------------------------
	inst:AddComponent("inspectable")
	-------------------------
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/hat_wizzard.xml"
	inst.components.inventoryitem.keepondeath = true
	-------------------------
	--inst:AddComponent("tradable")
	inst:AddComponent("dapperness")
	-------------------------
	inst:AddComponent("insulator")
	inst.components.insulator.insulation = TUNING.INSULATION_LARGE
	
	if IsDLCEnabled(CAPY_DLC) then 
		inst:AddComponent("waterproofer")
		inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_LARGE)
	elseif IsDLCEnabled(REIGN_OF_GIANTS) then 
		inst.components.insulator:SetSummer()
		inst.components.insulator:SetWinter()
		-- adjustment for sanity issues with waterlogging
		inst:AddComponent("waterproofer")
		inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_LARGE)
	end
	-------------------------
	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
	inst.components.equippable:SetOnEquip( onequip )
	inst.components.equippable:SetOnUnequip( onunequip )
	-------------------------
	inst:AddComponent("sentienthat")
	
	
	return inst
end

return Prefab( "common/inventory/hat_wizzard", fn, Assets)