require("stategraphs/commonstates")

local actionhandlers = 
{
    --ActionHandler(ACTIONS.GOHOME, "gohome"),
    --ActionHandler(ACTIONS.EAT, "eat"),
    ActionHandler(ACTIONS.CHOP, "chop"),
	ActionHandler(ACTIONS.MINE, "mine"),
	ActionHandler(ACTIONS.ATTACK, "attack"),
    ActionHandler(ACTIONS.LUGGAGE_PICKUP, "pickup"),
	ActionHandler(ACTIONS.STEAL, "pickup"),
	ActionHandler(ACTIONS.NET, "net"),
	ActionHandler(ACTIONS.DIG, "pickup"),
    --ActionHandler(ACTIONS.EQUIP, "pickup"),
    --ActionHandler(ACTIONS.ADDFUEL, "pickup"),
    --ActionHandler(ACTIONS.TAKEITEM, "pickup"),

}

if IsDLCEnabled(PORKLAND_DLC) then 
	NewAction = {
	ActionHandler(ACTIONS.HACK, "hack"),
	}
	for k,v in pairs(NewAction) do
		table.insert(actionhandlers, v)
	end
elseif IsDLCEnabled(CAPY_DLC) then 
	NewAction = {
	ActionHandler(ACTIONS.HACK, "hack"),
	}
	for k,v in pairs(NewAction) do
		table.insert(actionhandlers, v)
	end
elseif IsDLCEnabled(REIGN_OF_GIANTS) then 
    -- none
end

local events=
{
    CommonHandlers.OnStep(),
    --CommonHandlers.OnLocomote(true,true),
	CommonHandlers.OnLocomote(false,true),
    CommonHandlers.OnSleep(),
    CommonHandlers.OnFreeze(),
    CommonHandlers.OnAttack(),
    CommonHandlers.OnAttacked(true),
    CommonHandlers.OnDeath(),
    EventHandler("doaction", 
        function(inst, data) 
            if not inst.components.health:IsDead() and not inst.sg:HasStateTag("busy") then
                if data.action == ACTIONS.CHOP then
                    inst.sg:GoToState("chop", data.target)
                end
            end
        end),
    
}

local states=
{
     State{
        name = "idle",
        tags = {"idle", "canrotate"},
        
        onenter = function(inst, pushanim)
			inst.Physics:Stop()
			--print ("enter idle")
			if math.random() <0.05 then
				--print ("shaking")
				inst.AnimState:PushAnimation("shake")
				events=
				{
					EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
				}
			else
				--print ("shaking ELSE")
				inst.AnimState:PushAnimation("idle_loop")			
			end
			
            if not inst.sg.mem.pant_ducking or inst.sg:InNewState() then
				inst.sg.mem.pant_ducking = 1
			end
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },

        timeline=
        {
            TimeEvent(7*FRAMES, function(inst) 
				inst.sg.mem.pant_ducking = inst.sg.mem.pant_ducking or 1
				inst.SoundEmitter:PlaySound("dontstarve/creatures/chester/pant", nil, inst.sg.mem.pant_ducking) 
				if inst.sg.mem.pant_ducking and inst.sg.mem.pant_ducking > .35 then
					inst.sg.mem.pant_ducking = inst.sg.mem.pant_ducking - .05
				end
			end),
        },        
   },
	
	
    State {
		name = "frozen",
		tags = {"busy"},
		
        onenter = function(inst)
            inst.AnimState:PlayAnimation("frozen")
            inst.Physics:Stop()
            inst.components.highlight:SetAddColour(Vector3(82/255, 115/255, 124/255))
        end,
    },
    
    State{
        name = "death",
        tags = {"busy"},
        
        onenter = function(inst)
            inst.SoundEmitter:PlaySound("dontstarve/pig/grunt")
            inst.AnimState:PlayAnimation("death")
            inst.Physics:Stop()
            RemovePhysicsColliders(inst)            
            inst.components.lootdropper:DropLoot(Vector3(inst.Transform:GetWorldPosition()))            
        end,
        
    },
    
	State{
        name = "pickup",
        onenter = function(inst)
			--print ("attempting to pickup")
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("snap")
        end,
        onexit = function(inst)
            inst:PerformBufferedAction()
            --inst.SoundEmitter:KillSound("make")
        end,
        
		timeline=
        {
            
            TimeEvent(2*FRAMES, function(inst) inst:PerformBufferedAction() end ),
        },
		
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
    
	State{
        name = "net",
        onenter = function(inst)
			--print ("attempting to net")
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("snap")
        end,
        onexit = function(inst)
            inst:PerformBufferedAction()
			--print("this is what is inst", inst, inst.prefab)
			inst:FireFlyLight(inst)
            --inst.SoundEmitter:KillSound("make")
        end,
        
		timeline=
        {
            
            TimeEvent(2*FRAMES, function(inst) inst:PerformBufferedAction() end ),
        },
		
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
	
    State{
        name = "attack",
        tags = {"attack", "busy"},
        
        onenter = function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/pig/attack")
            inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh")
            inst.components.combat:StartAttack()
            inst.Physics:Stop()
            --inst.AnimState:PlayAnimation("atk")
			inst.AnimState:PlayAnimation("chomp")
        end,
        
        timeline=
        {
            --TimeEvent(13*FRAMES, function(inst) inst.components.combat:DoAttack() inst.sg:RemoveStateTag("attack") inst.sg:RemoveStateTag("busy") end),
			TimeEvent(4*FRAMES, function(inst) inst.components.combat:DoAttack() inst.sg:RemoveStateTag("attack") inst.sg:RemoveStateTag("busy") end),
        },
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },

    State{
        name = "chop",
        tags = {"chopping"},
        
        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("chomp")
        end,
        
        timeline=
        {
            
            TimeEvent(4*FRAMES, function(inst) inst:PerformBufferedAction() end ),
        },
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
    
	State{
        name = "mine",
        tags = {"mining"},
        
        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("chomp")
        end,
        
        timeline=
        {
            
            TimeEvent(8*FRAMES, function(inst) inst:PerformBufferedAction() end ),
        },
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
    
	State{
        name = "hack",
        tags = {"hacking"},
        
        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("chomp")
        end,
        
        timeline=
        {
            
            TimeEvent(2*FRAMES, function(inst) inst:PerformBufferedAction() end ),
        },
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
    
    State{
        name = "hit",
        tags = {"busy"},
        
        onenter = function(inst)
            inst.SoundEmitter:PlaySound("dontstarve/pig/oink")
            inst.AnimState:PlayAnimation("open")
			--inst.AnimState:PlayAnimation("hit")
            inst.Physics:Stop()            
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),
        },        
    },
    State{
        name = "open_idle",
        tags = {"busy", "open"},
        
        onenter = function(inst)
            inst.AnimState:PlayAnimation("idle_loop_open")
            
            if not inst.sg.mem.pant_ducking or inst.sg:InNewState() then
				inst.sg.mem.pant_ducking = 1
			end
            
        end,

        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("open_idle") end ),
        },

        timeline=
        {
        
        
            TimeEvent(3*FRAMES, function(inst) 
				inst.sg.mem.pant_ducking = inst.sg.mem.pant_ducking or 1
				inst.SoundEmitter:PlaySound("dontstarve/creatures/chester/pant", nil, inst.sg.mem.pant_ducking) 
				if inst.sg.mem.pant_ducking and inst.sg.mem.pant_ducking > .35 then
					inst.sg.mem.pant_ducking = inst.sg.mem.pant_ducking - .05
				end
			end),
        },        
    },

    State{
        name = "close",
        tags = {""},
        
        onenter = function(inst)
            inst.AnimState:PlayAnimation("closed")
			inst:FireFlyLight(inst)
        end,

        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),
        },

        timeline=
        {
            TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/chester/close") end),
        },        
    },    	
}

CommonStates.AddWalkStates(states,
{
	walktimeline = {
		TimeEvent(0*FRAMES, PlayFootstep ),
		TimeEvent(6*FRAMES, PlayFootstep ),
	},
})
CommonStates.AddRunStates(states,
{
	runtimeline = {
		TimeEvent(0*FRAMES, PlayFootstep ),
		TimeEvent(3*FRAMES, PlayFootstep ),
	},
})

CommonStates.AddSleepStates(states,
{
	sleeptimeline = 
	{
		TimeEvent(35*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/pig/sleep") end ),
	},
})


CommonStates.AddFrozenStates(states)

    
return StateGraph("Luggage", states, events, "idle", actionhandlers)

